<?php
/**
 * Created by PhpStorm.
 * User: 思维定制
 * Date: 2018/7/12
 * Time: 16:03
 */

namespace App\Http\Controllers\Api\V1;


use App\Models\MessagesFollowerModel;
use App\Models\MessagesInfoModel;
use App\Models\MessagesTagModel;
use App\Models\PaymentInfoModel;
use App\Models\UserInfoModel;
use App\Models\WechatAppModel;
use EasyWeChat\Factory;
use Illuminate\Http\Request;

class IndexController extends Controller
{
    private $pay_config;

    public function __construct()
    {
        $wechat_app = WechatAppModel::find(1);
        $this->pay_config = [
            'app_id' => $wechat_app->appId,
            'mch_id' => $wechat_app->mchId,
            'key'    => $wechat_app->key,

            'cert_path'  => public_path().'/pem/cert.pem',
            'key_path'   => public_path().'/pen/key.pem',
            'notify_url' => '/api/index/notify',
        ];
    }

    public function indexMenu(Request $request)
    {
        $data = $request->input();
        $menu = MessagesTagModel::orderBy('sort','Desc')->take(3)->get();
        if($data['tag_id'] == 0){
            $message = MessagesInfoModel::where('state',0)->orderBy('id','Desc')->paginate(1);
        } else {;
            $message = MessagesTagModel::find($data['tag_id'])->messgaes()->where('state',0)->orderBy('id','Desc')->paginate(1);
            //dd($message);
        }
        foreach ($message as $item){
            $user = UserInfoModel::find($item->user_id);
            $message->owner = $user->nickname;
        }
        return $this->api(compact('menu','message'));
    }



    public function indexMessage(Request $request)
    {
        $id = $request->input('id');

        $message = MessagesInfoModel::where([['state',0],['id',$id]])->first();
        if(!$message){
            $data = [
                'msg' => '该信息不存在或者已完成'
            ];
            return $this->api($data);
        }

        if($message->type == 1){
            $check_message = MessagesFollowerModel::where([['message_id',$message->id],['user_id',$this->getUserId()]])->first();
            if(!$check_message){
                $message->is_pay = 0;
            } else {
                $message->is_pay = 1;
            }
        } else {
            $message->is_pay = '';
        }
        return $this->api(compact('message'));
    }

    public function indexGetMessage(Request $request)
    {
        $id = $request->input('id');
        $message = MessagesInfoModel::where([['id',$id],['type',1]])->first();
        if(!$message){
            $data = [
                'msg' => '该信息不存在或者已完成'
            ];
            return $this->api($data);
        }
        $out_trade_no = 'We'.date('YmdHis').rand(1000,9999);
        $user = UserInfoModel::find($this->getUserId());
        $user->money -= $message->price;
        if($user->money<0){
            $data = [
                'msg' => '您的余额已不足，请先充值'
            ];
            return $this->api($data);
        }
        $user->save();
        $save['openid'] = $user->openid;
        $save['out_trade_no'] = $out_trade_no;
        $save['user_id'] = $this->getUserId();
        $save['price'] = $message->price;
        $save['type'] = 2;
        $res = PaymentInfoModel::create($save);
        if($res){

            $data = [
                'msg' => '购买成功',
            ];
            return $this->api($data);
        } else {
            $data = [
                'msg' => '购买失败',
            ];
            return $this->api($data);
        }
    }



}